#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

unsigned long long pi (unsigned long long v) {
        const int C[2] = { 1, 5 };
        char A[2][65536];
        unsigned P[2][8000], Z[2];
        unsigned a, b, c, f, i, j, k, l, m, n, o, p, r, w, y;
        n = 0;
        memset (Z, 0, sizeof (Z));
        w = 1 + v / 6;
        if (v >= 2) n++;
        if (v >= 3) n++;
        if (v >= 5) { n++; P[1][Z[1]++] = 5; }
        if (v >= 7) { n++; P[0][Z[0]++] = 7; }
        if (v >= 11) { n++; P[1][Z[1]++] = 11; }
        r = 65536;
        if (r > w) r = w;
        l = 1 + (unsigned) sqrt (r / 6);
        memset (A, 1, sizeof (A));
        for (m=0; m<2; m++) {
                c = C[m];
                for (p=0; p<2; p++) {
                        a = C[p];
                        for (i=0; i<l; i++) {
                                f = i * 6 + c;
                                if (f == 1) continue;
                                for (j=f; ; j+=f) {
                                        k = (j - a) / 6;
                                        if (k * 6 + a == j)
                                                if (k != i) break;
                                }
                                for (j=k; j<r; j+=f) A[p][j] = 0;
                        }
                }
        }
        for (p=0; p<2; p++) {
                c = C[p];
                k = (v - c) / 6 + 1;
                if (r > k) r = k;
                for (i=2; i<r; i++) {
                        if (A[p][i]) {
                                if (Z[p] < 8000) P[p][Z[p]++] = i * 6 + c;
                                n++;
                        }
                }
        }
        for (b=65536; b<=w; b+=65536) {
                r = b + 65536;
                if (r > w) r = w;
                l = 1 + (unsigned) (sqrt (r / 6));
                memset (A, 1, sizeof (A));
                for (m=0; m<2; m++) for (p=0; p<2; p++) {
                        a = C[p];
                        for (i=0; ; i++) {
                                f = P[m][i];
                                y = f / 6;
                                if (y >= l) break;
                                o = b * 6;
                                o += f - (o % f);
                                for (j=o; ;j+=f) {
                                        k = (j - a) / 6;
                                        if (k * 6 + a == j)
                                                if (k != y) break;
                                }
                                for (j=k; j<r; j+=f) A[p][j-b] = 0;
                        }
                }
                for (p=0; p<2; p++) {
                        c = C[p];
                        k = (v - c) / 6 + 1;
                        if (r > k) r = k;
                        l = r - b;
                        for (i=0; i<l; i++) n += A[p][i];
                }
        }
        return n;

}

int main (int argc, char *argv[]) {
        unsigned n;
        if (argc != 2) exit (1);
        sscanf (argv[1], "%u", &n);
        printf ("%llu\n", pi (n));
        exit (0);
}

